unit utils;

interface

uses sysutils, classes;

function readExtension(f:TStream; var extension:string):boolean;
procedure writeExtension(f:TStream; extension:string);

function GetTempDir: TFileName;

var startoffset:integer;
  
implementation

function readExtension(f:TStream; var extension:string):boolean;
var i:integer;
    e:array[1..4] of char;
begin
  result:=false;
  // identifier
  f.read(e,4);
  extension:=e;
  if extension<>'MEXT' then
    exit;

  // length of extension
  f.read(i,sizeof(i));
  // extension
  setlength(extension,i);
  f.read(pansichar(extension)^,i);
  result:=true;
end;

procedure writeExtension(f:TStream; extension:string);
var s:string;
    i:integer;
begin
  s:='MEXT';
  f.write(pansichar(s)^,4);
  i:=length(extension);
  f.write(i,sizeof(i));
  f.write(pansichar(extension)^,i);
end;

function GetTempDir: TFileName;
begin
  result:=getenvironmentvariable('TEMP');
  if result[length(result)]<>'\' then
    result:=result+'\';
end;

initialization
{$INCLUDE Size.pas}

end.
